(function (window, document, undefined) {
	var instance,
	Progress;

	window.define
	 && define('xmls', ['pr'], function (_Progress) {
		Progress = _Progress;
		return new xmls();
	}) || (
		window.xmls = new xmls(),
		Progress = window.Progress)

	function getCookie(name) {
		var matches = document.cookie.match(new RegExp(
					"(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"));
		return matches ? decodeURIComponent(matches[1]) : undefined;
	}
	function setCookie(name, value, options) {
		options = options || {};

		var expires = options.expires;

		if (typeof expires == "number" && expires) {
			var d = new Date();
			d.setTime(d.getTime() + expires * 1000);
			expires = options.expires = d;
		}
		if (expires && expires.toUTCString) {
			options.expires = expires.toUTCString();
		}

		value = encodeURIComponent(value);

		var updatedCookie = name + "=" + value;

		for (var propName in options) {
			updatedCookie += "; " + propName;
			var propValue = options[propName];
			if (propValue !== true) {
				updatedCookie += "=" + propValue;
			}
		}

		document.cookie = updatedCookie;
	}

	function serialize(document) {
		var serializer = new XMLSerializer();
		var xmlstr = '<?xml version="1.0" encoding="utf-8"?>\r\n' +
			serializer.serializeToString(document)
			.replace(/<\?.*?\?>/, '')
			.replace(/\r|\n|\t/gim, '')
			.replace(/(<.*?>)\s+(<.*?>)/g, '$1$2')
			.replace(/(<.*?>)\s+(<.*?>)/g, '$1$2')
			.replace(/ xmlns=".*?"/g, '')
			.replace(/<!--.*?-->/g, '')
			.split(/(<.*?>)/)
			.filter(function (e) {
				return e;
			})
			.map(function (e, i, a) {
				if (/^<[^/].*[^/]>$/.test(e)) { //<tag>
					e = '\r\n' + Array(++this.tab).join('\t') + e;
				}
				if (/^<\//.test(e)) { //</tag>
					if (/^<\/|\/>$/.test(a[i - 1]))
						e = '\r\n' + Array(this.tab).join('\t') + e;
					this.tab--
				}
				if (/\/>$/.test(e)) //<tag/>
					e = '\r\n' + Array(this.tab + 1).join('\t') + e;
				return e;
			}, {
				tab: 0
			})
			.join('')
			.replace(/^\r\n/, '');

		return new Blob([xmlstr], {
			type: 'text/xml; charset=utf-8'
		});
	}

	function xmls() {
		if (instance)
			return instance;
		function setFileInLocalSTR(num, file, callback) {
			var blob = file.slice(0, file.size);

			var reader = new FileReader();
			reader.onloadend = function (evt) {
				if (evt.target.readyState == FileReader.DONE) {
					localStorage['local_' + num] = evt.target.result;
				}
				callback();
			};
			reader.readAsText(blob);
		}
		function getFileInLocalSTR(num, callback) {
			var parser = new DOMParser(),
			doc = parser.parseFromString(localStorage['local_' + num], 'text/xml'),
			xml = doc.documentElement;
			setCookie('local_' + num, '0');
			callback(xml);
		}
		function getFileFromServer(num, callback) {
			var query = "type=" + (/\d+/.test(num)
					 ? num == 0
					 ? "cfg"
					 : "coproc&num=" + num
					 : num);
			$.ajax({
				url: "/~cfg_ask_xml?" + query,
				headers: exports.requestHeaders ? exports.requestHeaders : {},
				async: !!num,
				success: function (data) {
					if (num == 0)
						exports.TimeOffset = +data.documentElement.querySelector('RealTime>TimeZone').textContent;
					callback(data.documentElement);
				}
			});
		}
		function getFile(num, callback) {
			if (local[num])
				getFileInLocalSTR(num, callback);
			else
				getFileFromServer(num, callback);
		}
		function getUsers(num, callback) {
			$.ajax({
				url: '/~pwd_list',
				headers: exports.requestHeaders ? exports.requestHeaders : {},
				success: function (data) {
					/*data = data.replace(/\r|\n|\t/gim, '')
									.replace(/{(.*?):/g, '{"$1":')
									.replace(/ (.*?):/g, ' "$1":')
									.replace(/,]/g, ']');*/

					var users = JSON.parse(data),
							accs = {},
							docStr = '<KIPP_3><Passwords></Passwords><Access></Access></KIPP_3>',
							parser = new DOMParser(),
							docPass = parser.parseFromString(docStr, 'text/xml');

					var passw = docPass.querySelector('Passwords'),
							acc = docPass.querySelector('Access');

					for (var i = 0; i < users.length; i++) {
						users[i].Access = users[i].Access.split(',');

						var item = docPass.createElement('Item'),
							uid = docPass.createElement('uid'),
							login = docPass.createElement('Login'),
							pass = docPass.createElement('Password'),
							enab = docPass.createElement('Enable'),
							maxConn = docPass.createElement('MaxConnect'),
							wwwRoot = docPass.createElement('WwwRoot');
							//A = docPass.createElement('A');
						
						login.textContent = users[i].Name;
						enab.textContent = users[i].Enable;
						uid.textContent = users[i].ID;
						maxConn.textContent = users[i].MaxConn;
						wwwRoot.textContent = users[i].Dir;
						//A.textContent = u.join(',');
						
						item.appendChild(uid);
						item.appendChild(login);
						item.appendChild(pass);
						item.appendChild(enab);
						item.appendChild(maxConn);
						item.appendChild(wwwRoot);
						//item.appendChild(A);
						if (login.textContent != 'root') {
							passw.appendChild(item);
						}
						for (var j = 0; j < users[i].Access.length; j++) {
							if (!(users[i].Access[j] in accs)) accs[users[i].Access[j]] = [];
							if (accs[users[i].Access[j]].indexOf(uid.textContent) < 0) accs[users[i].Access[j]].push(uid.textContent);
						}
					}
					for(var ac in accs) {
						var item = docPass.createElement('Item'),
							name = docPass.createElement('Name'),
							list = docPass.createElement('List'),
							pass;
							
						name.textContent = ac;
						list.textContent = accs[ac].join(',');
						
						item.appendChild(name);
						item.appendChild(list);
						acc.appendChild(item);
						
						/*if (ac == 'tu' || ac == 'restart') {
							pass = docPass.createElement('Password');
							pass.textContent = '#*#'
							item.appendChild(pass);
						}*/
					}
					callback(docPass.documentElement);
				}
			});
		}
		function setXMLS(num, xml) {
			xmls[num] = xml;
			if (num < 11 && xmls[0].getAttribute('prm_type') == 'TM3COM') {
				getFile(++num, setXMLS.bind(null, num));
			}
		}

		var xmls = window['xmls'] = {},
			local = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10].map(function (i) {
				return !!(getCookie('local_' + i) * 1);
			});

		getFile(0, setXMLS.bind(null, 0));

		var userName = document.querySelector('#userinfo .name');
		if (userName && userName.textContent == 'root') getUsers('passw', setXMLS.bind(null, 'passw'));

		Object.defineProperty(xmls, 'save', {
			enumerable: false,
			value: function (num, callback, options, context) {
				function send(num, success) {
					var data = serialize(xmls[num].ownerDocument),
					saveToLocal = document
						.querySelector('#gears #saveform_local').checked,
					saveToDevice = document
						.querySelector('#gears #saveform_device').checked,
					result = saveToLocal * 1 + saveToDevice * 1;

					function checkResult() {
						if (--result == 0) {
							success();
						}
					}

					if (saveToLocal) {
						window.URL = window.webkitURL || window.URL;

						var a = document.createElement('a');
						a.download = 'config' + (num * 1 ? '_' + num : '') + '.xml';
						a.href = window.URL.createObjectURL(data);
						a.type = 'text/xml; charset=utf-8';
						a.click();
						window.URL.revokeObjectURL(a.href);
						checkResult();
					}

					if (saveToDevice) {
						var formData = new FormData();
						var query = "type=" + (/\d+/.test(num)
								 ? num == 0
								 ? "cfg"
								 : "coproc&num=" + num
								 : num);
						formData.append("config", data, 'config.xml');
						$.ajax({
							type: "POST",
							url: "/~cfg_send_xml?" + query,
							dataType: "text",
							success: checkResult,
							error: checkResult,
							contentType: false,
							processData: false,
							data: formData,
							headers: exports.requestHeaders || {}
						});
					}
				}

				function waitCallback() {
					if (num !== undefined) {
						if (result === null) {
							setTimeout(waitCallback, 100)
						} else {
							callback && callback.apply(context, options);
						}
					} else {
						var ready = !Object.keys(result).some(function (key) {
								return !result[key] === null;
							})
							if (!ready) {
								setTimeout(waitCallback, 100);
								return;
							}
							callback && callback.apply(context, options);
					}
				}

				function success(data) {
					result[i] = true;
					result[i++] = null;
					if (xmls_nums[i] == 'passw') i++; // пропускаю passw
					(i < xmls_nums.length) && send(xmls_nums[i], success, error);
				}

				function error(error) {
					result[i] = false;
					result[i++] = null;
					(i < xmls_nums.length) && send(xmls_nums[i], success, error);
				}

				var result,
				xmls_nums = Object.keys(xmls),
				i = 0;

				if (num == undefined) {
					result = {};
					xmls_nums.length &&
					send(xmls_nums[i], success, error);
				} else {
					num = '' + num;
					result = null;

					~xmls_nums.indexOf(num) &&
					send(num,
						function (data) {
						result = true
					},
						function (error) {
						result = false
					})
				}

				waitCallback();
			}
		});

		Object.defineProperty(xmls, 'local', {
			enumerable: false,
			value: function (num, file, callback) {
				var name = file.name;
				setCookie('local_' + num, '1');
				FS(setFileInFs.bind(null, num, file, callback, null));
			}
		})

		Object.defineProperty(xmls, 'load', {
			enumerable: false,
			value: function (callback) {
				var ready = 11;
				function checkReady() {
					if (!--ready) {
						callback();
					}
				}
				[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10].forEach(function (num) {
					var local = document.querySelector('#gears #loadform_local_' + num),
					files = local && local.files;
					if (!files || !files.length)
						return checkReady();

					setFileInLocalSTR(num, files[0], checkReady);
					setCookie('local_' + num, '1');
				});
			}
		})
		
		var handleImportFileSelect = function(evt){
			files = evt.target.files;
			if (!files.length) return;
			
			var reader = new FileReader();
			reader.onload = function() {
				var tXml = reader.result,
					parser = new DOMParser(),
					doc;
				
				try{
					doc = parser.parseFromString(tXml, 'text/xml');
				}catch(e){
					//косяк
				}
				var newTariff = doc.querySelector('Tariff');
				if (newTariff) {
					var tariff = xmls[0].querySelector('ASKUE>Tariff'),
							askue = tariff.parentElement
					askue.removeChild(tariff);
					askue.appendChild(newTariff);
					setFileInLocalSTR(0, serialize(xmls[0]), function(){
						setCookie('local_0', '1');
						setTimeout(location.reload.bind(location),100)
					});
				} else {
					//косяк
				}
			}
			reader.readAsText(files[0]);
		}
		
		Object.defineProperty(xmls, 'importTariff', {
			enumerable: false,
			value: function () {
				var inp = document.createElement('input');
				inp.type = 'file';
				inp.addEventListener('change', handleImportFileSelect, false);
				inp.accept = '.xml';
				inp.click();
			}
		});
		
		Object.defineProperty(xmls, 'exportTariff', {
			enumerable: false,
			value: function (doc, serial) {
					var data = serialize(doc);

					window.URL = window.webkitURL || window.URL;

					var a = document.createElement('a');
					a.download = 'tarrifs_' + serial + '.xml';
					a.href = window.URL.createObjectURL(data);
					a.type = 'text/xml; charset=utf-8';
					a.click();
					window.URL.revokeObjectURL(a.href);
			}
		});
		return instance = xmls;
	}
})(window, document, undefined);
